<template>
  <span>{{ log }}</span>
  <div>
    <h1>Proyectos</h1>
    <p>Selecciona una de las siguientes opciones:</p>
  </div>
  <div class="container">
    <div class="content">
      <button v-on:click="setFile(nameTypePrj.luna8266)">
        <img
          class="menuImagen"
          src="./img/projects-img/luna-prj-new.png"
        />
      </button>
      <p>Crear un nuevo proyecto Luna</p>
    </div>
    <div class="content">
      <button v-on:click="setFile(nameTypePrj.chuck)">
        <img
          class="menuImagen"
          src="./img/projects-img/chuck-logo2023w.png"
        />
      </button>
      <p>Crear un nuevo proyecto Chuck</p>
    </div>
    <div class="content">
      <button v-on:click="getFile()">
        <img
          class="menuImagen"
          src="./img/projects-img/inbox-out-svgrepo-com.png"
        />
      </button>
      <p>Abrir un proyecto</p>
    </div>
  </div>
  <!-- MODAL POPUP -->
  <FileSelectComponent
    :message="message"
    :trigger="triggerFileSelectModal"
    @setFileProject="receivedFileNameFromModal"
  ></FileSelectComponent>
  <NewFileComponent
    :nameTypeNewPrj="nameTypeNewPrj"
    :message="message"
    :trigger="triggerNewFileModal"
    @setFileProject="receivedFileNameFromModal"
  ></NewFileComponent>
</template>
<script lang="ts">
import { defineComponent, ref } from "vue";
import FileSelectComponent from "./modals/FileSelectComponent.vue";
import NewFileComponent from "./modals/NewFileComponent.vue";

import {
  CatalejoProjects,
  CatalejoDataPrj,
  getNewFileHandle,
  saveCatalejoPrj,
  getFileHandle,
} from "../host/index";

export default defineComponent({
  components: {
    FileSelectComponent,
    NewFileComponent,
  },
  emits: ["fromParentLoadProjectFromFile"],
  setup(_, context) {
    enum nameTypePrj {
      luna8266 = CatalejoProjects[0].name,
      chuck = CatalejoProjects[1].name,
    }
    const triggerFileSelectModal = ref(false);
    const triggerNewFileModal = ref(false);
    const log = ref();
    const message = ref();
    const nameTypeNewPrj = ref();

    const setFile = async (nameType: string) => {
      if (nw.process != undefined) {
        nameTypeNewPrj.value = nameType;
        message.value = "Crear un nuevo proyecto Catalejo";
        triggerNewFileModal.value = true;
      } else {
        const fileHandle = await getNewFileHandle();
        console.debug(fileHandle);
        if (fileHandle == undefined) {
          log.value = fileHandle.log;
          console.debug("Error en el fileHandle desde getNewFileHandle()");
        } else {
          const catalejoDataPrj = await CatalejoDataPrj.build(nameType);
          await saveCatalejoPrj(fileHandle, catalejoDataPrj);
          context.emit("fromParentLoadProjectFromFile", fileHandle);
        }
      }
    };
    const getFile = async () => {
      if (nw.process != undefined) {
        message.value = "Escoge un proyecto Catalejo para abrir";
        triggerFileSelectModal.value = true;
      } else {
        const fileHandle = await getFileHandle();
        if (fileHandle.fileHandle == undefined) {
          log.value = fileHandle.log;
        } else {
          context.emit("fromParentLoadProjectFromFile", fileHandle.fileHandle);
        }
      }
    };
    const receivedFileNameFromModal = (file) => {
      triggerFileSelectModal.value = false;
      triggerNewFileModal.value = false;
      if (file != undefined) {
        context.emit("fromParentLoadProjectFromFile", file);
      }
    };
    return {
      //-- VARS --
      log,
      nameTypePrj,
      nameTypeNewPrj,
      message,
      //-- METHODS --
      setFile,
      getFile,
      // -- EMITS FUNCTIONS --
      receivedFileNameFromModal,
      // -- MODAL TRIGGER --
      triggerFileSelectModal,
      triggerNewFileModal,
    };
  },
});
</script>
<style type="text/css">
.container {
  width: 90%;
  border-radius: 5px;
  /* outline: dashed 1px white; */
  display: flex;
  justify-content: center;
  align-items: center;
}
.content {
  height: 80px;
  width: 30%;
  float: left;
  margin: 10px;
  border-radius: 5px;
  margin: auto;
}

.content:hover {
}

.menuImagen:hover {
  width: 100%;
  cursor: pointer;
  background-color: gray;
  color: gray;
}

h1,p {
  text-align: center;
  color: white;
}
</style>
